## -----------------------------------------------------------------------------
## Group assignment app
## -----------------------------------------------------------------------------
## 
## Special cases to consider
## - duplicate scores
## - missing scores
## - Pre-assignment of special cases - SOLVED
## - Make sure to remove assigned subjects from all subjects when pre-assigning
## - Set class to output list and have plot function only accept correct class (not necessary for Shiny)
## - Use knitr::kable() to show sample data, alternatively use gt()
## - Handle [NA, 0, ""]
##
## I believe we are ready for a shiny app!


## -- START WITH THIS -- ##
old_wd<-getwd()

setwd(paste0(old_wd,"/apps/Assignment"))

shiny::runApp(appDir = "/Users/au301842/PAaSO/apps/Assignment",launch.browser = TRUE)

## App deployment

require(rsconnect)

keys<-suppressWarnings(read.csv("/Users/au301842/shinyapp_token.csv",colClasses = "character"))

rsconnect::setAccountInfo(name='cognitiveindex', 
                          token=keys$key[1], secret=keys$key[2])

deployApp()

source(paste0(old_wd,"/apps/app_deploy.R"))

setwd(old_wd)

## Raw sketch, doesn't load correctly...